using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Customers;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface ICustomerRepository
    {
        Task<BaseResult> Add(CustomerElastic Customer);

        Task<BaseResult> AddManyAsync(IEnumerable<CustomerElastic> Customers);

        Task<SmartTableResult<CustomerElastic>> Search(BoolQueryDescriptor<CustomerElastic> query);

        Task<SmartTableResult<CustomerElastic>> GetByIds(List<long> ids);
    }

    public class CustomerRepository : ICustomerRepository
    {
        private readonly ElasticIndex<CustomerElastic> _dbContext;

        public CustomerRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<CustomerElastic>(settings.Value.ClusterUrl, "inventorycustomer");
        }

        public async Task<SmartTableResult<CustomerElastic>> Search(BoolQueryDescriptor<CustomerElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(CustomerElastic Customer)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Customer);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<CustomerElastic> Customers)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Customers);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<CustomerElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<CustomerElastic>();
            var idsQ = new QueryContainerDescriptor<CustomerElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
    }
}